  import {ThreeObject} from './ThreeObject.js';
  import * as THREE from '/seed-env/__static/threejs/three.module.js';
//======================================================
export class Object3D extends ThreeObject {
//======================================================

    //---------------------------------------------------
    get_scene(){
    //---------------------------------------------------
        return this.parent.get_scene();
    }
    //---------------------------------------------------
    onMake() {
    //---------------------------------------------------
        this.debug=false;
        this.object3d=this.onBuild3d();
        this.get_scene().add(this.object3d);

    }
    //---------------------------------------------------
    onBuild3d() {
    //---------------------------------------------------

        return;
    }

    //---------------------------------------------------
    onAttach(parent) {
    //---------------------------------------------------
        if(this.object3d){
            this.get_scene().add(this.object3d);
        }
    }
    //---------------------------------------------------
    onDetach(parent) {
    //---------------------------------------------------
        if(this.object3d){
            this.get_scene().remove(this.object3d);
        }
    }
    //---------------------------------------------------
    helpers() {
    //---------------------------------------------------
        console.log("test");
        if(this.debug==false){
            this.debug=true;
            this.onDebugEnter();
        }else{
            this.debug=false;
            this.onDebugExit();
        }
    }
    //---------------------------------------------------
    onDebugEnter() {
    //---------------------------------------------------

        return;
    }
    //---------------------------------------------------
    onDebugExit() {
    //---------------------------------------------------

        return;
    }
    //---------------------------------------------------
    set_visible(visible=true) {
    //---------------------------------------------------

            this.object3d.visible = visible;

    }
    //---------------------------------------------------
    onRun(time) {
    //---------------------------------------------------

    }
    //---------------------------------------------------
}
//======================================================
